--- a/cmake/CMakeLists.txt
+++ b/cmake/CMakeLists.txt
@@ -814,10 +814,6 @@ if (onnxruntime_DISABLE_OPTIONAL_TYPE)
   add_compile_definitions(DISABLE_OPTIONAL_TYPE)
 endif()
 
-if (onnxruntime_USE_CUDA AND "${onnxruntime_CUDNN_HOME}" STREQUAL "")
-  message(FATAL_ERROR "onnxruntime_CUDNN_HOME required for onnxruntime_USE_CUDA")
-endif()
-
 
 get_filename_component(ONNXRUNTIME_ROOT "${ONNXRUNTIME_ROOT}" ABSOLUTE)
 get_filename_component(ORTTRAINING_ROOT "${ORTTRAINING_ROOT}" ABSOLUTE)
@@ -833,23 +829,23 @@ else()
   add_subdirectory(external/date EXCLUDE_FROM_ALL)
 endif()
 
-set(SAFEINT_INCLUDE_DIR ${REPO_ROOT}/cmake/external/SafeInt)
-add_library(safeint_interface INTERFACE)
-target_include_directories(safeint_interface INTERFACE ${SAFEINT_INCLUDE_DIR})
+find_package(SafeInt REQUIRED)
+add_library(safeint_interface ALIAS SafeInt::SafeInt)
 
 if (onnxruntime_PREFER_SYSTEM_LIB)
-  find_package(boost_mp11)
+  find_package(Boost REQUIRED)
+  add_library(Boost::mp11 ALIAS Boost::boost)
 endif()
 if (NOT TARGET Boost::mp11)
   add_subdirectory(external/mp11 EXCLUDE_FROM_ALL)
 endif()
 
-set(JSON_BuildTests OFF CACHE INTERNAL "")
-set(JSON_Install OFF CACHE INTERNAL "")
-add_subdirectory(external/json EXCLUDE_FROM_ALL)
+find_package(nlohmann_json REQUIRED)
 
 if (onnxruntime_PREFER_SYSTEM_LIB)
-  find_package(re2)
+  find_package(PkgConfig)
+  pkg_check_modules(re2 re2 REQUIRED IMPORTED_TARGET)
+  add_library(re2::re2 ALIAS PkgConfig::re2)
 endif()
 if (NOT TARGET re2::re2)
   add_subdirectory(external/re2 EXCLUDE_FROM_ALL)
@@ -893,6 +889,8 @@ else()
 endif()
 
 # TODO  do we have to add target_include_directories to each project that uses this?
+find_package(cpuinfo REQUIRED)
+#[[
 if (CPUINFO_SUPPORTED)
   set(PYTORCH_CPUINFO_DIR external/pytorch_cpuinfo)
   set(PYTORCH_CPUINFO_INCLUDE_DIR ${PYTORCH_CPUINFO_DIR}/include)
@@ -912,6 +910,7 @@ if (CPUINFO_SUPPORTED)
     target_compile_options(cpuinfo PRIVATE "-D_CRT_SECURE_NO_WARNINGS")
   endif()
 endif()
+]]
 
 # bounds checking behavior.
 # throw instead of calling terminate if there's a bounds checking violation.
@@ -928,7 +927,10 @@ set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX
 set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -DGSL_UNENFORCED_ON_CONTRACT_VIOLATION")
 set(CMAKE_CXX_FLAGS_MINSIZEREL "${CMAKE_CXX_FLAGS_MINSIZEREL} -DGSL_UNENFORCED_ON_CONTRACT_VIOLATION")
 
-include(eigen)
+#include(eigen)
+find_package(Eigen3 REQUIRED)
+add_library(eigen ALIAS Eigen3::Eigen)
+set(eigen_INCLUDE_DIRS "${EIGEN3_INCLUDE_DIRS}")
 
 #onnxruntime_EXTERNAL_LIBRARIES could contain onnx, onnx_proto,libprotobuf, cuda/cudnn,
 # dnnl/mklml, onnxruntime_codegen_tvm, tvm and pthread
@@ -1383,19 +1385,11 @@ else()
 endif()
 
 if (NOT onnxruntime_MINIMAL_BUILD)
-  add_subdirectory(external/onnx EXCLUDE_FROM_ALL)
+  find_package(ONNX REQUIRED)
 else()
   include(onnx_minimal)
 endif()
 
-target_compile_definitions(onnx PUBLIC $<TARGET_PROPERTY:onnx_proto,INTERFACE_COMPILE_DEFINITIONS> PRIVATE "__ONNX_DISABLE_STATIC_REGISTRATION")
-if (NOT onnxruntime_USE_FULL_PROTOBUF)
-  target_compile_definitions(onnx PUBLIC "__ONNX_NO_DOC_STRINGS")
-endif()
-set_target_properties(onnx PROPERTIES FOLDER "External/ONNX")
-set_target_properties(onnx_proto PROPERTIES FOLDER "External/ONNX")
-
-
 # fix a warning in onnx code we can't do anything about
 if (MSVC)
    string(APPEND CMAKE_CXX_FLAGS " -DEIGEN_HAS_C99_MATH") # required to be set explicitly to enable Eigen-Unsupported SpecialFunctions
@@ -1421,7 +1415,7 @@ if (onnxruntime_PREFER_SYSTEM_LIB)
   find_package(Flatbuffers)
 endif()
 if (Flatbuffers_FOUND)
-  add_library(flatbuffers ALIAS flatbuffers::flatbuffers)
+  add_library(flatbuffers ALIAS flatbuffers::flatbuffers_shared)
 else()
   add_subdirectory(external/flatbuffers EXCLUDE_FROM_ALL)
 endif()
@@ -1581,7 +1575,6 @@ if (onnxruntime_USE_CUDA)
     #CUDA 10.2 on Linux doesn't support C++17
     set(CMAKE_CUDA_STANDARD 14)
   endif()
-  file(TO_CMAKE_PATH ${onnxruntime_CUDNN_HOME} onnxruntime_CUDNN_HOME)
 
   if (NOT CMAKE_CUDA_ARCHITECTURES)
     if (CMAKE_LIBRARY_ARCHITECTURE STREQUAL "aarch64-linux-gnu")
--- a/cmake/onnxruntime_common.cmake
+++ b/cmake/onnxruntime_common.cmake
@@ -104,7 +104,7 @@ target_include_directories(onnxruntime_c
     PUBLIC
         ${OPTIONAL_LITE_INCLUDE_DIR})
 
-target_link_libraries(onnxruntime_common safeint_interface Boost::mp11)
+target_link_libraries(onnxruntime_common safeint_interface Boost::boost)
 
 if(NOT WIN32)
   target_include_directories(onnxruntime_common PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/external/nsync/public")
@@ -211,6 +211,6 @@ if (ARM64 OR ARM OR X86 OR X64 OR X86_64
 
     target_include_directories(onnxruntime_common PRIVATE ${PYTORCH_CPUINFO_INCLUDE_DIR})
     target_link_libraries(onnxruntime_common cpuinfo)
-    list(APPEND onnxruntime_EXTERNAL_LIBRARIES cpuinfo clog)
+    list(APPEND onnxruntime_EXTERNAL_LIBRARIES cpuinfo)
   endif()
 endif()
--- a/onnxruntime/core/common/safeint.h
+++ b/onnxruntime/core/common/safeint.h
@@ -32,7 +32,7 @@ class SafeIntExceptionHandler<onnxruntim
 #pragma GCC diagnostic ignored "-Wunused-but-set-parameter"
 #endif
 #endif
-#include "safeint/SafeInt.hpp"
+#include "SafeInt.hpp"
 #if defined(__GNUC__)
 #pragma GCC diagnostic pop
 #endif
--- a/cmake/onnxruntime_unittests.cmake
+++ b/cmake/onnxruntime_unittests.cmake
@@ -716,7 +716,7 @@ add_dependencies(onnx_test_data_proto on
 onnxruntime_add_include_to_target(onnx_test_data_proto onnx_proto)
 target_include_directories(onnx_test_data_proto PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
 set_target_properties(onnx_test_data_proto PROPERTIES FOLDER "ONNXRuntimeTest")
-onnxruntime_protobuf_generate(APPEND_PATH IMPORT_DIRS external/onnx TARGET onnx_test_data_proto)
+onnxruntime_protobuf_generate(APPEND_PATH IMPORT_DIRS ${ONNX_INCLUDE_DIRS} TARGET onnx_test_data_proto)
 
 #
 # onnxruntime_ir_graph test data
--- a/cmake/onnxruntime_providers.cmake
+++ b/cmake/onnxruntime_providers.cmake
@@ -506,7 +506,7 @@ if (onnxruntime_USE_TENSORRT)
     set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -Wno-unused-parameter -Wno-missing-field-initializers")
   endif()
   set(CXX_VERSION_DEFINED TRUE)
-  add_subdirectory(${ONNXRUNTIME_ROOT}/../cmake/external/onnx-tensorrt)
+  find_package(ONNXTensorRT REQUIRED)
   set(CMAKE_CXX_FLAGS ${OLD_CMAKE_CXX_FLAGS})
   if ( CMAKE_COMPILER_IS_GNUCC )
     set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -Wno-unused-parameter")
@@ -520,9 +520,7 @@ if (onnxruntime_USE_TENSORRT)
     target_compile_options(nvonnxparser_static PRIVATE /FIio.h /wd4100)
     target_compile_options(nvonnxparser PRIVATE /FIio.h /wd4100)
   endif()
-  include_directories(${ONNXRUNTIME_ROOT}/../cmake/external/onnx-tensorrt)
-  include_directories(${TENSORRT_INCLUDE_DIR})
-  set(trt_link_libs cudnn ${CMAKE_DL_LIBS} ${TENSORRT_LIBRARY})
+  set(trt_link_libs cudnn ONNXTensorRT::nvonnxparser ${CMAKE_DL_LIBS})
   set(onnxparser_link_libs nvonnxparser_static)
 
   file(GLOB_RECURSE onnxruntime_providers_tensorrt_cc_srcs CONFIGURE_DEPENDS
